// CppSample.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "tchar.h"
#include "CppSIAPI.h"
#include "CppSIAPITest.h"

#include <iostream>
#include <string>
//#include <atlstr.h>

CppSample::CppSIAPI *pCppSIAPI;

int _tmain(int argc, _TCHAR* argv[])
{
	try
	{
		CppSample::CppSIAPI myAPI = CppSample::CppSIAPI();
		pCppSIAPI = &myAPI;

		CppSample::CppSIAPITest myAPITest = CppSample::CppSIAPITest(pCppSIAPI);

		// A sample to create two Signals Sites and build a Freeway Diamond Interchange Network
		myAPITest.CreateFreewayDiamondInterchangeNetwork();

		wprintf(L"\n");

		// A sample to read Lane Disciplines data
		myAPITest.ReadLaneDisciplines();

		wprintf(L"\n");

		// A sample to read Priorities data
		myAPITest.ReadPrioritiesData();

		wprintf(L"\n");

		// A sample to create a Roundabout Site, set the Lane Disciplines specifically
		myAPITest.CreateRoundaboutSite();

		wprintf(L"\n");

		// A sample to create a Roundabout Site, call the method SetDefaultLaneDisciplines() to automatically set the default Lane Disciplines on all Approach Lanes
		myAPITest.CreateRoundaboutSite2();
	}
	catch (wchar_t* param)
	{
		wprintf(param);
	}

	std::cin.get();
	return 0;
}

